Attribute VB_Name = "MOD"
Option Explicit

Public Type POINTAPI
  x As Long
  y As Long
End Type

Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Type MSG
  hwnd As Long
  message As Long
  wParam As Long
  lParam As Long
  time As Long
  pt As POINTAPI
End Type

Public Type PAINTSTRUCT
  hdc As Long
  fErase As Long
  rcPaint As RECT
  fRestore As Long
  fIncUpdate As Long
  rgbReserved As Byte
End Type

Public Type WNDCLASS
  style As Long
  lpfnwndproc As Long
  cbClsextra As Long
  cbWndExtra2 As Long
  hInstance As Long
  hIcon As Long
  hCursor As Long
  hbrBackground As Long
  lpszMenuName As String
  lpszClassName As String
End Type

Public Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type

Public Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
End Type

Public Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As RGBQUAD
End Type

'USER32
Public Declare Function GetClientRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Public Declare Function BeginPaint Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPaint As PAINTSTRUCT) As Long
Public Declare Sub PostQuitMessage Lib "user32.dll" (ByVal nExitCode As Long)
Public Declare Function DefWindowProc Lib "user32.dll" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Public Declare Function EndPaint Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPaint As PAINTSTRUCT) As Long
Public Declare Function ShowWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Public Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, ByRef lpParam As Any) As Long
Public Declare Function RegisterClass Lib "user32.dll" Alias "RegisterClassA" (ByRef Class As WNDCLASS) As Long
Public Declare Function GetMessage Lib "user32.dll" Alias "GetMessageA" (ByRef lpMsg As MSG, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Public Declare Function UnregisterClass Lib "user32.dll" Alias "UnregisterClassA" (ByVal lpClassName As String, ByVal hInstance As Long) As Long
Public Declare Function DispatchMessage Lib "user32.dll" Alias "DispatchMessageA" (ByRef lpMsg As MSG) As Long
Public Declare Function TranslateMessage Lib "user32.dll" (ByRef lpMsg As MSG) As Long
Public Declare Function MessageBox Lib "user32.dll" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long

'GDI32
Public Declare Function GetStockObject Lib "gdi32.dll" (ByVal nIndex As Long) As Long
Public Declare Function TextOut Lib "gdi32.dll" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long

Public Const WM_DESTROY As Long = &H2
Public Const WM_LBUTTONUP As Long = &H202
Public Const WM_PAINT As Long = &HF&
Public Const DT_CENTER As Long = &H1
Public Const DT_SINGLELINE As Long = &H20
Public Const DT_VCENTER As Long = &H4
Public Const WM_CLOSE As Long = &H10
Public Const WM_RBUTTONUP As Long = &H205

Public Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal DX As Long, ByVal DY As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function GetCL Lib "kernel32.dll" Alias "GetCommandLineA" () As String

Public Type Scr
  A() As Byte
  l As Long: t As Long: r As Long: d As Long: w As Long: h As Long: y As Long: s As Long
  ' S           -  
  ' Y           -  
  ' L,T,R,D,W,H -     
End Type

Dim A(1) As Scr, bInfo As BITMAPINFO, n As Long, E(3) As String, f As Single
' A(0) -      
' A(1) -   
' n    - hWnd 
' E(x) -    
' f    -    

Public Sub main()
  Dim q As Long, w As Long
  E(0) = ""
  E(1) = ""
  E(2) = "01:    ."
  E(3) = "01:    ."
  '  
  Dim wc As WNDCLASS, M As MSG: q = 0
    wc.style = 0
    wc.lpfnwndproc = GetAddress(AddressOf WndProc)
    wc.cbClsextra = 0
    wc.cbWndExtra2 = 0
    wc.hInstance = App.hInstance
    wc.hIcon = 0
    wc.hCursor = 0
    wc.hbrBackground = GetStockObject(4)
    wc.lpszMenuName = ""
    wc.lpszClassName = E(0)
  If RegisterClass(wc) = 0 Then Call MessageBox(0, E(2), E(1), 0): Exit Sub
  '  
  n = CreateWindowEx(8, E(0), E(0), &H80000000, 0, 0, 640, 480, 0, 0, App.hInstance, ByVal 0)
  If n = 0 Then Call MessageBox(0, E(3), E(1), 0): Exit Sub
  
  ReDim A(0).A(1764000 * 4), A(1).A(1764000 * 4)
  bInfo.bmiHeader.biSize = 40
  bInfo.bmiHeader.biWidth = 1680
  bInfo.bmiHeader.biHeight = -1050
  bInfo.bmiHeader.biPlanes = 1
  bInfo.bmiHeader.biBitCount = 32
  bInfo.bmiHeader.biSizeImage = 1764000 * 4
  
  A(0).s = 7056000: A(0).w = 1680: A(0).h = 1050: A(0).r = A(0).w - 1: A(0).d = A(0).h - 1: A(0).y = A(0).w * 4
  For q = 0 To bInfo.bmiHeader.biSizeImage - 1 Step 4: A(0).A(q) = 0: A(0).A(q + 1) = 0: A(0).A(q + 2) = 0: Next ' BGRA
  
  'A(0).s = 7056000: A(1).l = 0: A(1).t = 0: A(1).w = 100: A(1).h = 100: A(1).r = A(1).l + A(1).w - 1: A(1).d = A(1).t + A(1).h - 1: A(1).y = A(1).w * 4
  'For w = 0 To A(1).d * A(1).y Step A(1).y
  '  For q = 0 To A(1).r * 4 Step 4
  '    A(1).A(w + q) = 255: A(1).A(w + q + 1) = 255: A(1).A(w + q + 2) = 255: A(1).A(w + q + 3) = 255
  '  Next
  'Next
  
  A(0).s = 102400: A(1).l = 0: A(1).t = 0: A(1).w = 160: A(1).h = 160: A(1).r = A(1).l + A(1).w - 1: A(1).d = A(1).t + A(1).h - 1: A(1).y = A(1).w * 4
  'A(0).s = 1228800: A(1).l = 0: A(1).t = 0: A(1).w = 640: A(1).h = 480: A(1).r = A(1).l + A(1).w - 1: A(1).d = A(1).t + A(1).h - 1: A(1).y = A(1).w * 4
  ReDim A(1).A(102400)
  Open "C:\RIS.txt" For Binary As 1
    Get #1, , A(1).A
  Close 1
  
  f = Timer
  Draw A(1), 50, 50, 320, 320, 0, 0, 80, 80, 0
  Draw A(1), 370, 50, 320, 320, 0, 0, 80, 80, 1
  Draw A(1), 690, 50, 320, 320, 0, 0, 80, 80, 2
  Draw A(1), 1010, 50, 320, 320, 0, 0, 80, 80, 5
  Draw A(1), 50, 370, 320, 320, 0, 0, 80, 80, 3
  Draw A(1), 370, 370, 320, 320, 0, 0, 80, 80, 6
  Draw A(1), 690, 370, 320, 320, 0, 0, 80, 80, 4
  f = Timer - f
  
  ShowWindow n, 3
    
  Do While GetMessage(M, 0&, 0&, 0&)
    Call TranslateMessage(M)
    Call DispatchMessage(M)
  Loop
  
  Call UnregisterClass(E(0), App.hInstance)
End Sub

Public Sub Draw(ByRef s As Scr, DX As Long, DY As Long, DW As Long, DH As Long, SX As Long, SY As Long, SW As Long, SH As Long, Optional V As Byte) '  
  ' S           -  
  ' dx,dy,dw,dh -   
  ' sx,sy,sw,sh -     
  ' V           -  
  
  Dim ww As Single, hh As Single, x As Long, y As Long, ds As Long, q As Long, w As Long, qw As Long, wx As Long, wy As Long, qx As Single, qy As Single, qb As Long, qg As Long, qr As Long
  ' ww,hh       -     
  ' x,y         -     
  ' q,w         -     
  ' ds          -    
  ' wx,wy       -    3  4
  ' qx,qy,qw    -  
  ' qb,qg,qr    -    3  4 
  
  SW = SW - 1: DW = DW - 1: SH = SH - 1: DH = DH - 1
  If V = 0 Then
    '  
    ww = SW / DW: hh = SH / DH: w = DY * A(0).y: y = 0: ds = SY * s.y + SX * 4
1:
    q = DX * 4: x = 0
2:
    A(0).A(w + q) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4) ' B
    A(0).A(w + q + 1) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1) ' G
    A(0).A(w + q + 2) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2) ' R
    A(0).A(w + q + 3) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3) ' A
    If x < DW Then
      x = x + 1: q = q + 4: GoTo 2
    ElseIf y < DH Then
      y = y + 1: w = w + A(0).y: GoTo 1
    End If
  ElseIf V = 1 Then
    '    (1)
    ww = SW / DW: hh = SH / DH: w = DY * A(0).y: y = 0: ds = SY * s.y + SX * 4
3:
    q = DX * 4: x = 0
4:
    If x = DW Or y = DH Then '      
      A(0).A(w + q) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4)
      A(0).A(w + q + 1) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1)
      A(0).A(w + q + 2) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2)
      A(0).A(w + q + 3) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3)
    Else
      qw = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4): qw = qw + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4): A(0).A(w + q) = qw \ 2
      qw = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1): qw = qw + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4 + 1): A(0).A(w + q + 1) = qw \ 2
      qw = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2): qw = qw + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4 + 2): A(0).A(w + q + 2) = qw \ 2
      qw = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3): qw = qw + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4 + 3): A(0).A(w + q + 3) = qw \ 2
    End If
    If x < DW Then
      x = x + 1: q = q + 4: GoTo 4
    ElseIf y < DH Then
      y = y + 1: w = w + A(0).y: GoTo 3
    End If
  ElseIf V = 2 Then
    '  22 (2)
    ww = SW / DW: hh = SH / DH: w = DY * A(0).y: y = 0: ds = SY * s.y + SX * 4
5:
    q = DX * 4: x = 0
6:
    If y = DH Or y = 0 Or x = DW Or x = 0 Then '    1   
        A(0).A(w + q) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4)
        A(0).A(w + q + 1) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1)
        A(0).A(w + q + 2) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2)
        A(0).A(w + q + 3) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3)
    Else
      qw = 0: qb = 0: qg = 0: qr = 0
      
        qb = qb + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4)  ' B
        qg = qg + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4 + 1)   ' G
        qr = qr + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4 + 2)   ' R
        qw = qw + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4 + 3)   ' A
        
        qb = qb + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4)  ' B
        qg = qg + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4 + 1)  ' G
        qr = qr + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4 + 2)  ' R
        qw = qw + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4 + 3)  ' A
                
        qb = qb + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4)   ' B
        qg = qg + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4 + 1)   ' G
        qr = qr + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4 + 2)   ' R
        qw = qw + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4 + 3)  ' A
        
        qb = qb + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4) ' B
        qg = qg + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4 + 1) ' G
        qr = qr + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4 + 2) ' R
        qw = qw + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x + 1) * ww) * 4 + 3) ' A
      
      A(0).A(w + q) = qb \ 4
      A(0).A(w + q + 1) = qg \ 4
      A(0).A(w + q + 2) = qr \ 4
      A(0).A(w + q + 3) = qw \ 4
    End If
    If x < DW Then
      x = x + 1: q = q + 4: GoTo 6
    ElseIf y < DH Then
      y = y + 1: w = w + A(0).y: GoTo 5
    End If
  ElseIf V = 3 Then
    '  33 (3)
    ww = SW / DW: hh = SH / DH: w = DY * A(0).y: y = 0: ds = SY * s.y + SX * 4
7:
    q = DX * 4: x = 0
8:
    If y = DH Or y = 0 Or x = DW Or x = 0 Then '    1   
        A(0).A(w + q) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4)
        A(0).A(w + q + 1) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1)
        A(0).A(w + q + 2) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2)
        A(0).A(w + q + 3) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3)
    Else
      qw = 0: qb = 0: qg = 0: qr = 0
      For wy = -1 To 1: For wx = -1 To 1
        qb = qb + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4) ' B
        qg = qg + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 1) ' G
        qr = qr + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 2) ' R
        qw = qw + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 3) ' A
      Next: Next
      A(0).A(w + q) = qb \ 9
      A(0).A(w + q + 1) = qg \ 9
      A(0).A(w + q + 2) = qr \ 9
      A(0).A(w + q + 3) = qw \ 9
    End If
    If x < DW Then
      x = x + 1: q = q + 4: GoTo 8
    ElseIf y < DH Then
      y = y + 1: w = w + A(0).y: GoTo 7
    End If
  ElseIf V = 4 Then
    '  55 (4)
    ww = SW / DW: hh = SH / DH: w = DY * A(0).y: y = 0: ds = SY * s.y + SX * 4
9:
    q = DX * 4: x = 0
10:
    If y > DH - 2 Or y < 2 Or x > DW - 2 Or x < 2 Then '    2   
      A(0).A(w + q) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4)
      A(0).A(w + q + 1) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1)
      A(0).A(w + q + 2) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2)
      A(0).A(w + q + 3) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3)
    Else
      qw = 0: qb = 0: qg = 0: qr = 0
      For wy = -2 To 2: For wx = -2 To 2
        qb = qb + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4) ' B
        qg = qg + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 1) ' G
        qr = qr + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 2) ' R
        qw = qw + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 3) ' A
      Next: Next
      A(0).A(w + q) = qb \ 25
      A(0).A(w + q + 1) = qg \ 25
      A(0).A(w + q + 2) = qr \ 25
      A(0).A(w + q + 3) = qw \ 25
    End If
    If x < DW Then
      x = x + 1: q = q + 4: GoTo 10
    ElseIf y < DH Then
      y = y + 1: w = w + A(0).y: GoTo 9
    End If
  ElseIf V = 5 Then
    '  3+3 (3+)
    ww = SW / DW: hh = SH / DH: w = DY * A(0).y: y = 0: ds = SY * s.y + SX * 4
11:
    q = DX * 4: x = 0
12:
    If y = DH Or y = 0 Or x = DW Or x = 0 Then '    1   
        A(0).A(w + q) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4)
        A(0).A(w + q + 1) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1)
        A(0).A(w + q + 2) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2)
        A(0).A(w + q + 3) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3)
    Else
      qw = 0: qb = 0: qg = 0: qr = 0
      
        qb = qb + s.A(ds + CInt((y - 1) * hh) * s.y + CInt((x) * ww) * 4)  ' B
        qg = qg + s.A(ds + CInt((y - 1) * hh) * s.y + CInt((x) * ww) * 4 + 1)   ' G
        qr = qr + s.A(ds + CInt((y - 1) * hh) * s.y + CInt((x) * ww) * 4 + 2)   ' R
        qw = qw + s.A(ds + CInt((y - 1) * hh) * s.y + CInt((x) * ww) * 4 + 3)   ' A
        
        qb = qb + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4)  ' B
        qg = qg + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4 + 1)  ' G
        qr = qr + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4 + 2)  ' R
        qw = qw + s.A(ds + CInt((y) * hh) * s.y + CInt((x + 1) * ww) * 4 + 3)  ' A
        
        qb = qb + s.A(ds + CInt((y) * hh) * s.y + CInt((x - 1) * ww) * 4)  ' B
        qg = qg + s.A(ds + CInt((y) * hh) * s.y + CInt((x - 1) * ww) * 4 + 1)  ' G
        qr = qr + s.A(ds + CInt((y) * hh) * s.y + CInt((x - 1) * ww) * 4 + 2)  ' R
        qw = qw + s.A(ds + CInt((y) * hh) * s.y + CInt((x - 1) * ww) * 4 + 3)  ' A
        
        qb = qb + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4)   ' B
        qg = qg + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4 + 1)   ' G
        qr = qr + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4 + 2)   ' R
        qw = qw + s.A(ds + CInt((y) * hh) * s.y + CInt((x) * ww) * 4 + 3)  ' A
        
        qb = qb + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4) ' B
        qg = qg + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4 + 1)  ' G
        qr = qr + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4 + 2)  ' R
        qw = qw + s.A(ds + CInt((y + 1) * hh) * s.y + CInt((x) * ww) * 4 + 3)  ' A
      
      A(0).A(w + q) = qb \ 5
      A(0).A(w + q + 1) = qg \ 5
      A(0).A(w + q + 2) = qr \ 5
      A(0).A(w + q + 3) = qw \ 5
    End If
    If x < DW Then
      x = x + 1: q = q + 4: GoTo 12
    ElseIf y < DH Then
      y = y + 1: w = w + A(0).y: GoTo 11
    End If
  ElseIf V = 6 Then
    '  5o5 (4-)
    ww = SW / DW: hh = SH / DH: w = DY * A(0).y: y = 0: ds = SY * s.y + SX * 4
13:
    q = DX * 4: x = 0
14:
    If y > DH - 3 Or y < 3 Or x > DW - 3 Or x < 3 Then '    3   
      A(0).A(w + q) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4)
      A(0).A(w + q + 1) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 1)
      A(0).A(w + q + 2) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 2)
      A(0).A(w + q + 3) = s.A(ds + CInt(y * hh) * s.y + CInt(x * ww) * 4 + 3)
    Else
      qw = 0: qb = 0: qg = 0: qr = 0
      For wy = -2 To 2: For wx = -2 To 2
        If Abs(wy) + Abs(wx) < 3 Then
          qb = qb + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4) ' B
          qg = qg + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 1) ' G
          qr = qr + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 2) ' R
          qw = qw + s.A(ds + CInt((y + wy) * hh) * s.y + CInt((x + wx) * ww) * 4 + 3) ' A
        End If
      Next: Next
      A(0).A(w + q) = qb \ 13
      A(0).A(w + q + 1) = qg \ 13
      A(0).A(w + q + 2) = qr \ 13
      A(0).A(w + q + 3) = qw \ 13
    End If
    If x < DW Then
      x = x + 1: q = q + 4: GoTo 14
    ElseIf y < DH Then
      y = y + 1: w = w + A(0).y: GoTo 13
    End If
  End If
End Sub

Private Function WndProc(ByVal hwnd As Long, ByVal message As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Dim ps As PAINTSTRUCT, hdc As Long, mRect As RECT
  Select Case message
    Case WM_DESTROY
      Call PostQuitMessage(0&)
    Case WM_PAINT
      hdc = BeginPaint(n, ps)
      Call GetClientRect(n, mRect)
        SetDIBitsToDevice hdc, 0, 0, A(0).w, A(0).h, 0, 0, 0, A(0).h, A(0).A(0), bInfo, 0
        TextOut hdc, 0, 0, CStr(f), Len(CStr(f))
      Call EndPaint(n, ps)
    Case WM_LBUTTONUP, WM_RBUTTONUP
      Call SendMessage(n, WM_CLOSE, 0&, 0&)
  End Select
  
  WndProc = DefWindowProc(hwnd, message, wParam, lParam)
 End Function

Public Function GetAddress(ByVal lngAddr As Long) As Long
  GetAddress = lngAddr
End Function
